/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IAEQKSRT_H
#define _IAEQKSRT_H

#include <iaequal.h>
#include <iakey.h>
#include <iasrt.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#pragma SOMAsDefault (off)

template <class Element, class Key>
class IAEqualityKeySortedCollection :
  public IAEqualityCollection <Element>,
  public IAKeyCollection <Element, Key>,
  public IASortedCollection <Element> {

  typedef  IACollectionImpl Implementation;

public:

           IAEqualityKeySortedCollection
                            (INotifier&);

          ~IAEqualityKeySortedCollection
                            ();

protected:

           IAEqualityKeySortedCollection
                            ();

           IAEqualityKeySortedCollection
                            (IAEqualityKeySortedCollection
                              <Element, Key> const&);

private:


};
   
#pragma SOMAsDefault (pop)

#include <iaeqksrt.inl>

#pragma info (restore)
#pragma pack ()

#endif
