/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _ICOMPAT_H
#define _ICOMPAT_H

#define  IBagOnBSTKeySortedSet                  IBagAsBstTree
#define IGBagOnBSTKeySortedSet                 IGBagAsBstTree
#define  IBagOnHashKeySet                       IBagAsHshTable
#define IGBagOnHashKeySet                      IGBagAsHshTable
#define  IBagOnSortedDilutedSequence            IBagAsDilTable
#define IGBagOnSortedDilutedSequence           IGBagAsDilTable
#define  IBagOnSortedLinkedSequence             IBagAsList
#define IGBagOnSortedLinkedSequence            IGBagAsList
#define  IBagOnSortedTabularSequence            IBagAsTable
#define IGBagOnSortedTabularSequence           IGBagAsTable

#define  IDequeOnDilutedSequence                IDequeAsDilTable
#define IGDequeOnDilutedSequence               IGDequeAsDilTable
#define  IDequeOnTabularSequence                IDequeAsTable
#define IGDequeOnTabularSequence               IGDequeAsTable

#define  IEqualitySequenceOnDilutedSequence\
                                     IEqualitySequenceAsDilTable
#define IGEqualitySequenceOnDilutedSequence\
                                    IGEqualitySequenceAsDilTable
#define  IEqualitySequenceOnTabularSequence\
                                     IEqualitySequenceAsTable
#define IGEqualitySequenceOnTabularSequence\
                                    IGEqualitySequenceAsTable

#define  IHeapOnDilutedSequence                 IHeapAsDilTable
#define IGHeapOnDilutedSequence                IGHeapAsDilTable
#define  IHeapOnTabularSequence                 IHeapAsTable
#define IGHeapOnTabularSequence                IGHeapAsTable

#define  IHashKeyBag                            IKeyBagAsHshTable
#define IGHashKeyBag                           IGKeyBagAsHshTable

#define  IKeySetOnBSTKeySortedSet               IKeySetAsBstTree
#define IGKeySetOnBSTKeySortedSet              IGKeySetAsBstTree
#define  IHashKeySet                            IKeySetAsHshTable
#define IGHashKeySet                           IGKeySetAsHshTable
#define  IKeySetOnSortedDilutedSequence         IKeySetAsDilTable
#define IGKeySetOnSortedDilutedSequence        IGKeySetAsDilTable
#define  IKeySetOnSortedLinkedSequence          IKeySetAsList
#define IGKeySetOnSortedLinkedSequence         IGKeySetAsList
#define  IKeySetOnSortedTabularSequence         IKeySetAsTable
#define IGKeySetOnSortedTabularSequence        IGKeySetAsTable

#define  IKeySortedBagOnSortedDilutedSequence   IKeySortedBagAsDilTable
#define IGKeySortedBagOnSortedDilutedSequence  IGKeySortedBagAsDilTable
#define  IKeySortedBagOnSortedTabularSequence   IKeySortedBagAsTable
#define IGKeySortedBagOnSortedTabularSequence  IGKeySortedBagAsTable

#define  IAvlKeySortedSet                       IKeySortedSetAsAvlTree
#define IGAvlKeySortedSet                      IGKeySortedSetAsAvlTree
#define  IBSTKeySortedSet                       IKeySortedSetAsBstTree
#define IGBSTKeySortedSet                      IGKeySortedSetAsBstTree
#define  IKeySortedSetOnSortedDilutedSequence   IKeySortedSetAsDilTable
#define IGKeySortedSetOnSortedDilutedSequence  IGKeySortedSetAsDilTable
#define  IKeySortedSetOnSortedLinkedSequence    IKeySortedSetAsList
#define IGKeySortedSetOnSortedLinkedSequence   IGKeySortedSetAsList
#define  IKeySortedSetOnSortedTabularSequence   IKeySortedSetAsTable
#define IGKeySortedSetOnSortedTabularSequence  IGKeySortedSetAsTable

#define  IMapOnBSTKeySortedSet                  IMapAsBstTree
#define IGMapOnBSTKeySortedSet                 IGMapAsBstTree
#define  IMapOnHashKeySet                       IMapAsHshTable
#define IGMapOnHashKeySet                      IGMapAsHshTable
#define  IMapOnSortedDilutedSequence            IMapAsDilTable
#define IGMapOnSortedDilutedSequence           IGMapAsDilTable
#define  IMapOnSortedLinkedSequence             IMapAsList
#define IGMapOnSortedLinkedSequence            IGMapAsList
#define  IMapOnSortedTabularSequence            IMapAsTable
#define IGMapOnSortedTabularSequence           IGMapAsTable

#define  IPriorityQueueOnSortedDilutedSequence  IPriorityQueueAsDilTable
#define IGPriorityQueueOnSortedDilutedSequence IGPriorityQueueAsDilTable
#define  IPriorityQueueOnSortedTabularSequence  IPriorityQueueAsTable
#define IGPriorityQueueOnSortedTabularSequence IGPriorityQueueAsTable

#define  IQueueOnDilutedSequence                IQueueAsDilTable
#define IGQueueOnDilutedSequence               IGQueueAsDilTable
#define  IQueueOnTabularSequence                IQueueAsTable
#define IGQueueOnTabularSequence               IGQueueAsTable

#define  IDilutedSequence                       ISequenceAsDilTable
#define IGDilutedSequence                      IGSequenceAsDilTable
#define  ILinkedSequence                        ISequenceAsList
#define IGLinkedSequence                       IGSequenceAsList
#define  ITabularSequence                       ISequenceAsTable
#define IGTabularSequence                      IGSequenceAsTable

#define  ISetOnBSTKeySortedSet                  ISetAsBstTree
#define IGSetOnBSTKeySortedSet                 IGSetAsBstTree
#define  ISetOnHashKeySet                       ISetAsHshTable
#define IGSetOnHashKeySet                      IGSetAsHshTable
#define  ISetOnSortedDilutedSequence            ISetAsDilTable
#define IGSetOnSortedDilutedSequence           IGSetAsDilTable
#define  ISetOnSortedLinkedSequence             ISetAsList
#define IGSetOnSortedLinkedSequence            IGSetAsList
#define  ISetOnSortedTabularSequence            ISetAsTable
#define IGSetOnSortedTabularSequence           IGSetAsTable

#define  ISortedBagOnBSTKeySortedSet            ISortedBagAsBstTree
#define IGSortedBagOnBSTKeySortedSet           IGSortedBagAsBstTree
#define  ISortedBagOnSortedDilutedSequence      ISortedBagAsDilTable
#define IGSortedBagOnSortedDilutedSequence     IGSortedBagAsDilTable
#define  ISortedBagOnSortedLinkedSequence       ISortedBagAsList
#define IGSortedBagOnSortedLinkedSequence      IGSortedBagAsList
#define  ISortedBagOnSortedTabularSequence      ISortedBagAsTable
#define IGSortedBagOnSortedTabularSequence     IGSortedBagAsTable

#define  ISortedMapOnBSTKeySortedSet            ISortedMapAsBstTree
#define IGSortedMapOnBSTKeySortedSet           IGSortedMapAsBstTree
#define  ISortedMapOnSortedDilutedSequence      ISortedMapAsDilTable
#define IGSortedMapOnSortedDilutedSequence     IGSortedMapAsDilTable
#define  ISortedMapOnSortedLinkedSequence       ISortedMapAsList
#define IGSortedMapOnSortedLinkedSequence      IGSortedMapAsList
#define  ISortedMapOnSortedTabularSequence      ISortedMapAsTable
#define IGSortedMapOnSortedTabularSequence     IGSortedMapAsTable

#define  ISortedRelationOnSortedDilutedSequence\
                                        ISortedRelationAsDilTable
#define IGSortedRelationOnSortedDilutedSequence\
                                       IGSortedRelationAsDilTable
#define  ISortedRelationOnSortedTabularSequence\
                                        ISortedRelationAsTable
#define IGSortedRelationOnSortedTabularSequence\
                                       IGSortedRelationAsTable

#define  ISortedSetOnBSTKeySortedSet            ISortedSetAsBstTree
#define IGSortedSetOnBSTKeySortedSet           IGSortedSetAsBstTree
#define  ISortedSetOnSortedDilutedSequence      ISortedSetAsDilTable
#define IGSortedSetOnSortedDilutedSequence     IGSortedSetAsDilTable
#define  ISortedSetOnSortedLinkedSequence       ISortedSetAsList
#define IGSortedSetOnSortedLinkedSequence      IGSortedSetAsList
#define  ISortedSetOnSortedTabularSequence      ISortedSetAsTable
#define IGSortedSetOnSortedTabularSequence     IGSortedSetAsTable

#define  IStackOnDilutedSequence                IStackAsDilTable
#define IGStackOnDilutedSequence               IGStackAsDilTable
#define  IStackOnTabularSequence                IStackAsTable
#define IGStackOnTabularSequence               IGStackAsTable

#define  IVBagOnBSTKeySortedSet                 IVBag
#define IVGBagOnBSTKeySortedSet                IVGBag
#define  IVBagOnHashKeySet                      IVBag
#define IVGBagOnHashKeySet                     IVGBag
#define  IVBagOnSortedDilutedSequence           IVBag
#define IVGBagOnSortedDilutedSequence          IVGBag
#define  IVBagOnSortedLinkedSequence            IVBag
#define IVGBagOnSortedLinkedSequence           IVGBag
#define  IVBagOnSortedTabularSequence           IVBag
#define IVGBagOnSortedTabularSequence          IVGBag

#define  IVDequeOnDilutedSequence               IVDeque
#define IVGDequeOnDilutedSequence              IVGDeque
#define  IVDequeOnTabularSequence               IVDeque
#define IVGDequeOnTabularSequence              IVGDeque

#define  IVEqualitySequenceOnDilutedSequence    IVEqualitySequence
#define IVGEqualitySequenceOnDilutedSequence   IVGEqualitySequence
#define  IVEqualitySequenceOnTabularSequence    IVEqualitySequence
#define IVGEqualitySequenceOnTabularSequence   IVGEqualitySequence

#define  IVHeapOnDilutedSequence                IVHeap
#define IVGHeapOnDilutedSequence               IVGHeap
#define  IVHeapOnTabularSequence                IVHeap
#define IVGHeapOnTabularSequence               IVGHeap

#define  IVHashKeyBag                           IVKeyBag
#define IVGHashKeyBag                          IVGKeyBag

#define  IVKeySetOnBSTKeySortedSet              IVKeySet
#define IVGKeySetOnBSTKeySortedSet             IVGKeySet
#define  IVHashKeySet                           IVKeySet
#define IVGHashKeySet                          IVGKeySet
#define  IVKeySetOnSortedDilutedSequence        IVKeySet
#define IVGKeySetOnSortedDilutedSequence       IVGKeySet
#define  IVKeySetOnSortedLinkedSequence         IVKeySet
#define IVGKeySetOnSortedLinkedSequence        IVGKeySet
#define  IVKeySetOnSortedTabularSequence        IVKeySet
#define IVGKeySetOnSortedTabularSequence       IVGKeySet

#define  IVKeySortedBagOnSortedDilutedSequence  IVKeySortedBag
#define IVGKeySortedBagOnSortedDilutedSequence IVGKeySortedBag
#define  IVKeySortedBagOnSortedTabularSequence  IVKeySortedBag
#define IVGKeySortedBagOnSortedTabularSequence IVGKeySortedBag

#define  IVAvlKeySortedSet                      IVKeySortedSet
#define IVGAvlKeySortedSet                     IVGKeySortedSet
#define  IVBSTKeySortedSet                      IVKeySortedSet
#define IVGBSTKeySortedSet                     IVGKeySortedSet
#define  IVKeySortedSetOnSortedDilutedSequence  IVKeySortedSet
#define IVGKeySortedSetOnSortedDilutedSequence IVGKeySortedSet
#define  IVKeySortedSetOnSortedLinkedSequence   IVKeySortedSet
#define IVGKeySortedSetOnSortedLinkedSequence  IVGKeySortedSet
#define  IVKeySortedSetOnSortedTabularSequence  IVKeySortedSet
#define IVGKeySortedSetOnSortedTabularSequence IVGKeySortedSet

#define  IVMapOnBSTKeySortedSet                 IVMap
#define IVGMapOnBSTKeySortedSet                IVGMap
#define  IVMapOnHashKeySet                      IVMap
#define IVGMapOnHashKeySet                     IVGMap
#define  IVMapOnSortedDilutedSequence           IVMap
#define IVGMapOnSortedDilutedSequence          IVGMap
#define  IVMapOnSortedLinkedSequence            IVMap
#define IVGMapOnSortedLinkedSequence           IVGMap
#define  IVMapOnSortedTabularSequence           IVMap
#define IVGMapOnSortedTabularSequence          IVGMap

#define  IVPriorityQueueOnSortedDilutedSequence\
                                            IVPriorityQueue
#define IVGPriorityQueueOnSortedDilutedSequence\
                                           IVGPriorityQueue
#define  IVPriorityQueueOnSortedTabularSequence\
                                            IVPriorityQueue
#define IVGPriorityQueueOnSortedTabularSequence\
                                           IVGPriorityQueue

#define  IVQueueOnDilutedSequence               IVQueue
#define IVGQueueOnDilutedSequence              IVGQueue
#define  IVQueueOnTabularSequence               IVQueue
#define IVGQueueOnTabularSequence              IVGQueue

#define  IVDilutedSequence                      IVSequence
#define IVGDilutedSequence                     IVGSequence
#define  IVLinkedSequence                       IVSequence
#define IVGLinkedSequence                      IVGSequence
#define  IVTabularSequence                      IVSequence
#define IVGTabularSequence                     IVGSequence

#define  IVSetOnBSTKeySortedSet                 IVSet
#define IVGSetOnBSTKeySortedSet                IVGSet
#define  IVSetOnHashKeySet                      IVSet
#define IVGSetOnHashKeySet                     IVGSet
#define  IVSetOnSortedDilutedSequence           IVSet
#define IVGSetOnSortedDilutedSequence          IVGSet
#define  IVSetOnSortedLinkedSequence            IVSet
#define IVGSetOnSortedLinkedSequence           IVGSet
#define  IVSetOnSortedTabularSequence           IVSet
#define IVGSetOnSortedTabularSequence          IVGSet

#define  IVSortedBagOnBSTKeySortedSet           IVSortedBag
#define IVGSortedBagOnBSTKeySortedSet          IVGSortedBag
#define  IVSortedBagOnSortedDilutedSequence     IVSortedBag
#define IVGSortedBagOnSortedDilutedSequence    IVGSortedBag
#define  IVSortedBagOnSortedLinkedSequence      IVSortedBag
#define IVGSortedBagOnSortedLinkedSequence     IVGSortedBag
#define  IVSortedBagOnSortedTabularSequence     IVSortedBag
#define IVGSortedBagOnSortedTabularSequence    IVGSortedBag

#define  IVSortedMapOnBSTKeySortedSet           IVSortedMap
#define IVGSortedMapOnBSTKeySortedSet          IVGSortedMap
#define  IVSortedMapOnSortedDilutedSequence     IVSortedMap
#define IVGSortedMapOnSortedDilutedSequence    IVGSortedMap
#define  IVSortedMapOnSortedLinkedSequence      IVSortedMap
#define IVGSortedMapOnSortedLinkedSequence     IVGSortedMap
#define  IVSortedMapOnSortedTabularSequence     IVSortedMap
#define IVGSortedMapOnSortedTabularSequence    IVGSortedMap

#define  IVSortedRelationOnSortedDilutedSequence\
                                        IVSortedRelation
#define IVGSortedRelationOnSortedDilutedSequence\
                                       IVGSortedRelation
#define  IVSortedRelationOnSortedTabularSequence\
                                        IVSortedRelation
#define IVGSortedRelationOnSortedTabularSequence\
                                       IVGSortedRelation

#define  IVSortedSetOnBSTKeySortedSet           IVSortedSet
#define IVGSortedSetOnBSTKeySortedSet          IVGSortedSet
#define  IVSortedSetOnSortedDilutedSequence     IVSortedSet
#define IVGSortedSetOnSortedDilutedSequence    IVGSortedSet
#define  IVSortedSetOnSortedLinkedSequence      IVSortedSet
#define IVGSortedSetOnSortedLinkedSequence     IVGSortedSet
#define  IVSortedSetOnSortedTabularSequence     IVSortedSet
#define IVGSortedSetOnSortedTabularSequence    IVGSortedSet

#define  IVStackOnDilutedSequence               IVStack
#define IVGStackOnDilutedSequence              IVGStack
#define  IVStackOnTabularSequence               IVStack
#define IVGStackOnTabularSequence              IVGStack

#define IPartCollection                   IACollection
#define IPartOrderedCollection            IAOrderedCollection
#define IPartCollectionNotification       IVCollectionImpl
#define IPartCollectionEventData          IVCollectionEventData
#define IPartCollectionAddedEventData     IVCollectionEventData
#define IPartCollectionRemovedEventData   IVCollectionEventData
#define IPartCollectionReplacedEventData  IVCollectionEventData

#define IPtr      IElemPointer
#define IMgPtr IMngElemPointer

#endif
