#ifndef _ICRITSEC_
#define _ICRITSEC_
/*******************************************************************************
* FILE NAME: icritsec.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     ICritSec                                                                 *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>

class ICritSecData;

#pragma pack(4)

class ICritSec : public IBase {
typedef IBase
  Inherited;
public:
/*------------------------------- Constructors -------------------------------*/
  ICritSec ( );
 ~ICritSec ( );

/*------------------------------- Diagnostics --------------------------------*/
static unsigned long
  count    ( );

private:
/*------------------------------ Hidden Members ------------------------------*/
  ICritSec   ( const ICritSec& section );
ICritSec
 &operator=  ( const ICritSec& section );

/*--------------------------------- Private ----------------------------------*/
static unsigned long
  fgCount;
ICritSecData
 *fCritSecData;

}; // ICritSec

#pragma pack()

#endif /* _ICRITSEC_ */
