/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

// ---
// IGDequeCursor
// ---

// public members

template <class Element, class ElementOps>
inline
IGDequeCursor <Element, ElementOps>::
IGDequeCursor
  (IGDeque
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGDequeCursor <Element, ElementOps>&
IGDequeCursor <Element, ElementOps>::
operator=
  (IGDequeCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGDequeCursor <Element, ElementOps>::
IGDequeCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}

// ---
// IGDeque
// ---

// public members

template <class Element, class ElementOps>
inline
IGDeque <Element, ElementOps>::
IGDeque (INumber numberOfElements)
{ SetImpl ((Implementation*) *new
                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGDeque <Element, ElementOps>::
IGDeque
  (IGDeque
    <Element, ElementOps> const& collection)
{ CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGDeque <Element, ElementOps>&
IGDeque <Element, ElementOps>::
operator= (IGDeque
            <Element, ElementOps> const& collection)
{ ImplOf (*this).Copy (ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGDeque <Element, ElementOps>::
IGDeque (PureImplementation& impl)
{ SetImpl (&impl);
}

template <class Element, class ElementOps>
inline IGDeque
 <Element, ElementOps>::Implementation&
IGDeque <Element, ElementOps>::
ImplOf (IGDeque
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IDeque
// ---

// public members

template <class Element>
inline
IDeque <Element>::
IDeque (INumber numberOfElements)
: IGDeque
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IDeque <Element>::
IDeque (PureImplementation& impl)
: IGDeque
   <Element, IStdOps <Element> > (impl)
{
}

// ---
// IVGDeque
// ---

// public members

template <class Element, class ElementOps>
inline
IVGDeque <Element, ElementOps>::
IVGDeque (INumber numberOfElements)
: IGDeque
    <Element, ElementOps> (*(Implementation*) *new
                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGDeque <Element, ElementOps>::
IVGDeque (PureImplementation& impl)
: IGDeque
    <Element, ElementOps> (impl)
{
}

// ---
// IVDeque
// ---

// public members

template <class Element>
inline
IVDeque <Element>::
IVDeque (INumber numberOfElements)
: IVGDeque
   <Element, IStdOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVDeque <Element>::
IVDeque (PureImplementation& impl)
: IVGDeque
   <Element, IStdOps <Element> > (impl)
{
}
