/********************************************************************************/
/* File:  idspmbsq.inl                                                          */
/* Class: IDSParameterBufferSequence                                            */
/*                                                                              */
/* IDSParameterBufferSequence - sequence of parm buffers                        */
/********************************************************************************/
/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1996.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#include "idspmbsq.hpp"

/*------------------------------------------------------------------------------
|   bindToStatement - bind all parameters in seq to statement                  |
------------------------------------------------------------------------------*/
inline void IDSParameterBufferSequence::bindToStatement(
                                           ISQLStatement* pSqlStatement)
{
  statementInfo info(pSqlStatement);
  allElementsDo (bindParameter, &info);
}

/*------------------------------------------------------------------------------
|   bindParameter  - bind a parameter to a statement                           |
------------------------------------------------------------------------------*/
inline Boolean IDSParameterBufferSequence::bindParameter(
                               IPOBufferBase*& pBuffer,
                                                           void* someInfo)
{
  statementInfo* info = (statementInfo*)someInfo;
  pBuffer->bindToParameter(info->number++, info->sqlStatement);
  return true;
}
