/****************************************************************************/
/* File:   idssqlst.hpp                                                     */
/* Class:  ISQLStatement                                                    */
/*                                                                          */
/****************************************************************************/

/***********************************************

    Licensed Materials - Property of IBM

    5622-880   5801-AAR

    (c) Copyright IBM Corp 1991, 1996.

************************************************/

#ifndef _IDSSQLST_HPP_
#define _IDSSQLST_HPP_

#include <istring.hpp>

class IDatastoreDB2;
class IDatastoreODBC;
class ISQLStatementProxy;

class _Export ISQLStatement
{
  public:
    ISQLStatement(IDatastoreDB2* pIDatastore);
    ISQLStatement(IDatastoreODBC* pIDatastore);
    ~ISQLStatement();

    ISQLStatement& executeDirect(const IString& statement);
    ISQLStatement& prepare(const IString& statement);
    ISQLStatement& execute();
    Boolean fetch();
    long rowCount();
    short numResultCols();
    short numParams();
    Boolean moreResults();
    Boolean bindColumn(short colPos, short fCType, void *pBuf,
                              long cbBufMax, void *pcbBuf);
    ISQLStatement& bindParameter(short parPos, short fParamType,
                                 short fCType, short fSqlType, long cbParDef,
                                 short ibScale, void *pBuf, long cbBufMax,
                                 void *pcbBuf
                                 );
    ISQLStatement& rollback();

  private:
    ISQLStatementProxy *pSqlPrx;
};

#endif
