/******************************************************************************/
/* File:   idsstad.inl                                                        */
/* Class:                                                                     */
/*         IDSStatementAdd                                                    */
/*                                                                            */
/******************************************************************************/

/***********************************************

    Licensed Materials - Property of IBM

    5622-880   5801-AAR

    (c) Copyright IBM Corp 1991, 1996.

************************************************/

//#include "idsstad.hpp"

/*-----------------------------------------------------------------+
|  Constructor                                                     |
+-----------------------------------------------------------------*/
inline IDSStatementAdd::IDSStatementAdd(const char* aStatement,
                                        IDatastoreDB2* aDatastore )
          :IDSStatement(aStatement,aDatastore)
{

}

inline IDSStatementAdd::IDSStatementAdd(const char* aStatement,
                                        IDatastoreODBC* aDatastore )
          :IDSStatement(aStatement,aDatastore)
{

}

/*-----------------------------------------------------------------+
|  Destructor                                                      |
+-----------------------------------------------------------------*/
inline IDSStatementAdd::~IDSStatementAdd()
{

}

inline IDSStatementAdd&
IDSStatementAdd::execute()
{
    parameterBuffers.bindToStatement( iSQLStatement );
    iSQLStatement->executeDirect(iStatement);
    switch (iSQLStatement->rowCount()) {
      case 0:
        {
          IString strError = ClsEnv::daxMsg(DAX_MSG_OBJECT_NOT_FOUND_OR_NOT_INSERTED);
          IDADataObjectNotFound exc(strError,DAX_MSG_OBJECT_NOT_FOUND_OR_NOT_INSERTED,IException::recoverable);
          ITHROW (exc);
        }
      case 1:
        break;  // OK
      default:
      {
          //iSQLStatement->rollback();
          IString strError = ClsEnv::daxMsg(DAX_MSG_OBJECT_NOT_UNIQUE);
          IDADataObjectInvalid exc(strError,DAX_MSG_OBJECT_NOT_UNIQUE,IException::recoverable);
          ITHROW (exc);
      }
    }
    return *this;
}
