/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IESDIL_H
#define _IESDIL_H

#include <iaes.h>
#include <iices.h>
#include <iives.h>
#include <iiesdil.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#pragma SOMAsDefault (off)

template <class Element, class ElementOps>
class IGEqualitySequenceAsDilTable;

template <class Element, class ElementOps>
class IGEqualitySequenceAsDilTableCursor :
  public IOrderedCursor <Element> {

  typedef  IOrderedCursor <Element> Inherited;

  typedef  IGEqualitySequenceAsDilTable
            <Element, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGEqualitySequenceAsDilTableCursor
                            (IGEqualitySequenceAsDilTable
                              <
                               Element, ElementOps> const&);

  IGEqualitySequenceAsDilTableCursor <Element, ElementOps>&
           operator=        (IGEqualitySequenceAsDilTableCursor
                              <
                               Element, ElementOps> const&);

protected:

           IGEqualitySequenceAsDilTableCursor
                            (ICursorImpl*);

private:


};

template <class Element, class ElementOps>
class IGEqualitySequenceAsDilTable :
  public IAEqualitySequence <Element> {
protected:

  typedef  IGEqualitySequenceAsDilTable <Element, ElementOps> Self;

  typedef  IEqualitySequenceAsDilTableImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICEqualitySequenceImpl
            <PureImplementation> Implementation;
#endif

#define IGEqualitySequenceAsDilTableTypedef(Element, ElementOps)\
  typedef  IEqualitySequenceAsDilTableOps\
            <Element,\
             IWEOps <Element, ElementOps>,\
             Implementation> Instantiation

           IGEqualitySequenceAsDilTableTypedef (Element, ElementOps);

public:

  typedef  IGEqualitySequenceAsDilTableCursor
            <Element, ElementOps> Cursor;


           IGEqualitySequenceAsDilTable
                            (INumber = 100);

           IGEqualitySequenceAsDilTable
                            (IGEqualitySequenceAsDilTable
                              <
                               Element, ElementOps> const&);

  IGEqualitySequenceAsDilTable <Element, ElementOps>&
           operator=        (IGEqualitySequenceAsDilTable
                              <
                               Element, ElementOps> const&);


protected:

           IGEqualitySequenceAsDilTable
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGEqualitySequenceAsDilTable
                              <
                               Element, ElementOps> const&);

private:

  friend
  class    IGEqualitySequenceAsDilTableCursor
            <Element, ElementOps>;



};

template <class Element>
class IEqualitySequenceAsDilTable :
  public IGEqualitySequenceAsDilTable
          <Element, IEOps <Element> > {

  typedef  IGEqualitySequenceAsDilTable
            <Element,
             IEOps <Element> > Inherited;

protected:

  typedef  IEqualitySequenceAsDilTable <Element> Self;

#define IEqualitySequenceAsDilTableTypedef(Element)\
  typedef  IEqualitySequenceAsDilTableOps\
            <Element,\
             IWEOps <Element, IEOps <Element> >,\
             Implementation> Instantiation

public:

           IEqualitySequenceAsDilTable
                            (INumber = 100);


protected:

           IEqualitySequenceAsDilTable
                              (PureImplementation&);

private:


};

template <class Element, class ElementOps>
class IVGEqualitySequenceAsDilTable :
  public IGEqualitySequenceAsDilTable
          <Element, ElementOps > {

  typedef  IVGEqualitySequenceAsDilTable
            <Element, ElementOps> Inherited;

protected:

#if defined (INO_CHECKS)
  typedef  IVEqualitySequenceImpl
            <PureImplementation> Implementation;
#else
  typedef  ICEqualitySequenceImpl
            <IVEqualitySequenceImpl
              <PureImplementation> > Implementation;
#endif

#define IVGEqualitySequenceAsDilTableTypedef(Element, ElementOps)\
  typedef  IEqualitySequenceAsDilTableOps\
            <Element,\
             IWEOps <Element, ElementOps>,\
             Implementation> Instantiation

           IVGEqualitySequenceAsDilTableTypedef (Element, ElementOps);

public:

           IVGEqualitySequenceAsDilTable
                            (INumber = 100);


protected:

           IVGEqualitySequenceAsDilTable
                              (PureImplementation&);

private:


};

template <class Element>
class IVEqualitySequenceAsDilTable :
  public IVGEqualitySequenceAsDilTable
          <Element, IEOps <Element> > {

  typedef  IVGEqualitySequenceAsDilTable
            <Element,
             IEOps <Element> > Inherited;

protected:

  typedef  IVEqualitySequenceAsDilTable <Element> Self;

#define IVEqualitySequenceAsDilTableTypedef(Element)\
  typedef  IVEqualitySequenceAsDilTableOps\
            <Element,\
             IWEOps <Element, IEOps <Element> >,\
             Implementation> Instantiation

public:

           IVEqualitySequenceAsDilTable
                            (INumber = 100);


protected:

           IVEqualitySequenceAsDilTable
                              (PureImplementation&);

private:


};

#pragma SOMAsDefault (pop)

#include <iesdil.inl>

#pragma info (restore)
#pragma pack ()

#endif
