/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IIASR_H
#define _IIASR_H

#include <iiacllct.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#pragma SOMAsDefault (off)

class IASortedRelationImpl : public IACollectionImpl {
public:

          ~IASortedRelationImpl
                            ();

  virtual
  void     Antivalence      (IASortedRelationImpl const&);

  virtual
  void     AddAntivalence   (IASortedRelationImpl const&,
                             IASortedRelationImpl const&); 

  virtual
  void     AddDifference    (IASortedRelationImpl const&,
                             IASortedRelationImpl const&); 

  virtual
  void     AddIntersection  (IASortedRelationImpl const&,
                             IASortedRelationImpl const&);

  virtual
  void     AddUnion         (IASortedRelationImpl const&,
                             IASortedRelationImpl const&);

  virtual
  long     Compare          (IASortedRelationImpl const&,
                             ICompFunc, void*) const;

  virtual
  void     Difference       (IASortedRelationImpl const&);

  virtual
  void     Intersection     (IASortedRelationImpl const&);

  virtual
  void     Union            (IASortedRelationImpl const&);

  virtual
  IBoolean operator==       (IASortedRelationImpl const&) const = 0;

  IBoolean operator!=       (IASortedRelationImpl const&) const;

protected:

           IASortedRelationImpl
                            (Ops&);

  INumber  NumberOfOccurrences
                            (void const*) const;

  INumber  RemoveAllOccurrences
                            (void const*);

private:


};

#pragma SOMAsDefault (pop)

#pragma info (restore)
#pragma pack ()

#endif
