/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IIBAGDIL_H
#define _IIBAGDIL_H

#include <iibagkb.h>


#include <iikbdil.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#pragma SOMAsDefault (off)

typedef IBagOnKeyBagImpl
         <IKeyBagAsDilTableImpl> IBagAsDilTableImpl;

typedef IABagOnKeyBagOps
         <IKeyBagAsDilTableImpl> IABagAsDilTableOps;

template <class Element, class ElementOps, class Implementation>
class IBagAsDilTableOps :
  public IABagAsDilTableOps {

  typedef  IABagAsDilTableOps Inherited;

  typedef  IBagAsDilTableOps
            <Element, ElementOps, Implementation> Self;

  typedef  IKeyBagAsDilTableOps
            <Element, Element, IOpsWithKey <Element, ElementOps>,
             IKeyBagAsDilTableImpl> Base;

public:

  typedef  Implementation ImplType;

  typedef  Element ElementType;

  typedef  void KeyType;

           IBagAsDilTableOps
                           (INumber);

           IBagAsDilTableOps
                           (INumber, void*);

           IBagAsDilTableOps
                           (IBagAsDilTableOps
                             <Element, ElementOps,
                              Implementation> const&);

          ~IBagAsDilTableOps
                           ();

  IACollectionImpl*
           Clone           () const;

           operator IKeyBagAsDilTableImpl&
                           ();

           operator Implementation*
                           ();


protected:

private:

  Base     ivBase;

  Implementation
           ivImpl;


};

#pragma SOMAsDefault (pop)

#if ! defined (__TEMPINC__)
#include <iibagdil.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
