/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IIKEYOPS_H
#define _IIKEYOPS_H

#include <iistream.h>
#include <inumpos.h>
#include <stddef.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#pragma SOMAsDefault(off)

// indirection for keys

template <class Key>
void* IKeyFromOps (Key const&);

template <class Key>
Key const& IKeyForOps (Key const*);

// key extension

template <class Element, class ElementOps>
class IOpsWithKey : public ElementOps {
public:

  ElementOps
           keyOps;

           IOpsWithKey      ();

           IOpsWithKey      (void*);

  Element const&
           Key              (Element const&) const;

protected:

private:

};

#pragma SOMAsDefault(pop)

#include <iikeyops.inl>

#pragma info (restore)
#pragma pack ()

#endif
