/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

// ---
// IKeySetAsDilTableOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
IKeySetAsDilTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
IKeySetAsDilTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
IKeySetAsDilTableOps
  (IKeySetAsDilTableOps
    <Element, Key, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
~IKeySetAsDilTableOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
operator IKeySortedSetAsDilTableImpl& ()
{ return *(IKeySortedSetAsDilTableImpl*)ivBase ;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySetAsDilTableOps <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}

#pragma info (restore)
#pragma pack ()
