/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IISMTAB_H
#define _IISMTAB_H

#include <iismkss.h>


#include <iiksstab.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#pragma SOMAsDefault (off)

typedef ISortedMapOnKeySortedSetImpl
         <IKeySortedSetAsTableImpl> ISortedMapAsTableImpl;

typedef IASortedMapOnKeySortedSetOps
         <IKeySortedSetAsTableImpl> IASortedMapAsTableOps;
template <class Element, class _Key,
          class ElementOps, class Implementation>
class ISortedMapAsTableOps :
  public IASortedMapAsTableOps {

  typedef  ISortedMapAsTableOps
            <Element, _Key, ElementOps, Implementation> Self;

  typedef  IKeySortedSetAsTableOps
            <Element, _Key,
             ElementOps, IKeySortedSetAsTableImpl> Base;

public:

  typedef  Implementation ImplType;

  typedef  Element ElementType;

  typedef  _Key KeyType;

           ISortedMapAsTableOps
                           (INumber);

           ISortedMapAsTableOps
                           (INumber, void*);

           ISortedMapAsTableOps
                           (ISortedMapAsTableOps
                             <Element, _Key,
                              ElementOps, Implementation> const&);

          ~ISortedMapAsTableOps
                           ();

  IACollectionImpl*
           Clone           () const;

  IBoolean EqualElements   (void const*, void const*) const;

  TStream& operator<<=     (TStream&);

  TStream& operator>>=     (TStream&) const;

           operator IKeySortedSetAsTableImpl&
                           ();

           operator Implementation*
                           ();


protected:

private:

  ElementOps
           ivElementOps;
 
  Base     ivBase;

  Implementation
           ivImpl;


};

#pragma SOMAsDefault (pop)

#if ! defined (__TEMPINC__)
#include <iismtab.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
