/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IIVBAG_H
#define _IIVBAG_H

#include <iiabag.h>

#pragma SOMAsDefault (off)

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template <class VInherited>
class IVBagImpl : public VInherited {
public:

  typedef  VInherited::Ops Ops;

           IVBagImpl
                            (Ops&, INumber);

           IVBagImpl
                            (Ops&, IVBagImpl
                                    <VInherited> const&);

  IBoolean Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  void     AddAntivalence   (IABagImpl const&,
                             IABagImpl const&);

  void     AddDifference    (IABagImpl const&,
                             IABagImpl const&);

  void     AddIntersection  (IABagImpl const&,
                             IABagImpl const&);

  void     AddUnion         (IABagImpl const&,
                             IABagImpl const&);

  void     Antivalence      (IABagImpl const&);

  void     Copy             (IACollectionImpl const&);

  void     Difference       (IABagImpl const&);

  void     Intersection     (IABagImpl const&);

  IBoolean LocateOrAdd      (void const*, ICursorImpl&);

  IBoolean Remove           (void const*);

  INumber  RemoveAll        ();

  INumber  RemoveAll        (IPredFunc, void*);

  INumber  RemoveAllOccurrences
                            (void const*);

  void     RemoveAt         (ICursorImpl&);

  void     ReplaceAt        (ICursorImpl const&, void const*);

  void     Union            (IABagImpl const&);

protected:

private:


};

#pragma SOMAsDefault (pop)

#if ! defined (__TEMPINC__)
#include <iivbag.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
