/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IKSBDIL_H
#define _IKSBDIL_H

#include <iaksb.h>
#include <iicksb.h>
#include <iivksb.h>
#include <iiksbdil.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#pragma SOMAsDefault (off)

template <class Element, class Key, class ElementOps>
class IGKeySortedBagAsDilTable;

template <class Element, class Key, class ElementOps>
class IGKeySortedBagAsDilTableCursor :
  public IOrderedCursor <Element> {

  typedef  IOrderedCursor <Element> Inherited;

  typedef  IGKeySortedBagAsDilTable
            <Element, Key, ElementOps>::
              Implementation::Cursor Implementation;

public:

           IGKeySortedBagAsDilTableCursor
                            (IGKeySortedBagAsDilTable
                              <
                               Element, Key, ElementOps> const&);

  IGKeySortedBagAsDilTableCursor <Element, Key, ElementOps>&
           operator=        (IGKeySortedBagAsDilTableCursor
                              <
                               Element, Key, ElementOps> const&);

protected:

           IGKeySortedBagAsDilTableCursor
                            (ICursorImpl*);

private:


};

template <class Element, class Key, class ElementOps>
class IGKeySortedBagAsDilTable :
  public IAKeySortedBag <Element, Key> {
protected:

  typedef  IGKeySortedBagAsDilTable <Element, Key, ElementOps> Self;

  typedef  IKeySortedBagAsDilTableImpl PureImplementation;

#if defined (INO_CHECKS)
  typedef  PureImplementation Implementation;
#else
  typedef  ICKeySortedBagImpl
            <PureImplementation> Implementation;
#endif

#define IGKeySortedBagAsDilTableTypedef(Element, Key, ElementOps)\
  typedef  IKeySortedBagAsDilTableOps\
            <Element, Key,\
             IWKCOps <Element, Key, ElementOps>,\
             Implementation> Instantiation

           IGKeySortedBagAsDilTableTypedef (Element, Key, ElementOps);

public:

  typedef  IGKeySortedBagAsDilTableCursor
            <Element, Key, ElementOps> Cursor;


           IGKeySortedBagAsDilTable
                            (INumber = 100);

           IGKeySortedBagAsDilTable
                            (IGKeySortedBagAsDilTable
                              <
                               Element, Key, ElementOps> const&);

  IGKeySortedBagAsDilTable <Element, Key, ElementOps>&
           operator=        (IGKeySortedBagAsDilTable
                              <
                               Element, Key, ElementOps> const&);


protected:

           IGKeySortedBagAsDilTable
                            (PureImplementation&);

  static
  Implementation&
           ImplOf           (IGKeySortedBagAsDilTable
                              <
                               Element, Key, ElementOps> const&);

private:

  friend
  class    IGKeySortedBagAsDilTableCursor
            <Element, Key, ElementOps>;



};

template <class Element, class Key>
class IKeySortedBagAsDilTable :
  public IGKeySortedBagAsDilTable
          <Element, Key, IKCOps <Element, Key> > {

  typedef  IGKeySortedBagAsDilTable
            <Element, Key,
             IKCOps <Element, Key> > Inherited;

protected:

  typedef  IKeySortedBagAsDilTable <Element, Key> Self;

#define IKeySortedBagAsDilTableTypedef(Element, Key)\
  typedef  IKeySortedBagAsDilTableOps\
            <Element, Key,\
             IWKCOps <Element, Key, IKCOps <Element, Key> >,\
             Implementation> Instantiation

public:

           IKeySortedBagAsDilTable
                            (INumber = 100);


protected:

           IKeySortedBagAsDilTable
                              (PureImplementation&);

private:


};

template <class Element, class Key, class ElementOps>
class IVGKeySortedBagAsDilTable :
  public IGKeySortedBagAsDilTable
          <Element, Key, ElementOps > {

  typedef  IVGKeySortedBagAsDilTable
            <Element, Key, ElementOps> Inherited;

protected:

#if defined (INO_CHECKS)
  typedef  IVKeySortedBagImpl
            <PureImplementation> Implementation;
#else
  typedef  ICKeySortedBagImpl
            <IVKeySortedBagImpl
              <PureImplementation> > Implementation;
#endif

#define IVGKeySortedBagAsDilTableTypedef(Element, Key, ElementOps)\
  typedef  IKeySortedBagAsDilTableOps\
            <Element, Key,\
             IWKCOps <Element, Key, ElementOps>,\
             Implementation> Instantiation

           IVGKeySortedBagAsDilTableTypedef (Element, Key, ElementOps);

public:

           IVGKeySortedBagAsDilTable
                            (INumber = 100);


protected:

           IVGKeySortedBagAsDilTable
                              (PureImplementation&);

private:


};

template <class Element, class Key>
class IVKeySortedBagAsDilTable :
  public IVGKeySortedBagAsDilTable
          <Element, Key, IKCOps <Element, Key> > {

  typedef  IVGKeySortedBagAsDilTable
            <Element, Key,
             IKCOps <Element, Key> > Inherited;

protected:

  typedef  IVKeySortedBagAsDilTable <Element, Key> Self;

#define IVKeySortedBagAsDilTableTypedef(Element, Key)\
  typedef  IVKeySortedBagAsDilTableOps\
            <Element, Key,\
             IWKCOps <Element, Key, IKCOps <Element, Key> >,\
             Implementation> Instantiation

public:

           IVKeySortedBagAsDilTable
                            (INumber = 100);


protected:

           IVKeySortedBagAsDilTable
                              (PureImplementation&);

private:


};

#pragma SOMAsDefault (pop)

#include <iksbdil.inl>

#pragma info (restore)
#pragma pack ()

#endif
