#ifndef _IMPHDR_
  #define _IMPHDR_
/*******************************************************************************
* FILE NAME: imphdr.hpp                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IMousePointerHandler                                                     *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <imoushdr.hpp>
#include <imousevt.hpp>


#pragma pack(4)

class IMousePointerHandler : public IMouseHandler {
typedef IMouseHandler
  Inherited;

public:
/*------------------------------- Constructors -------------------------------*/
  IMousePointerHandler       ( );

virtual
 ~IMousePointerHandler       ( );

/*-------------------------------- Accessors ---------------------------------*/
static IMousePointerHandler
 *defaultHandler ( );

protected:
/*----------------------------- Event Processing -----------------------------*/
virtual Boolean
  dispatchHandlerEvent ( IEvent&             event );

virtual Boolean
  mousePointerChange   ( IMousePointerEvent& event );

}; // IMousePointerHandler

#pragma pack()

#endif // _IMPHDR_
