/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _ITREE_H
#define _ITREE_H

#include <imwt.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#pragma SOMAsDefault (off)

template <class Element, class ElementOps, INumber numOfChildren>
class IGTree :
  public IGMultiwayTree <numOfChildren, Element, ElementOps> {

  typedef  IGMultiwayTree
            <numOfChildren, Element, ElementOps> Inherited;

public:

  IGTree <Element, ElementOps, numOfChildren>&
           operator=        (IGTree <Element, ElementOps,
                                     numOfChildren> const& tree)
           { Inherited::operator= (tree);
             return *this;
           }

protected:

private:


};

template <class Element, INumber numOfChildren>
class ITree :
  public IGTree <Element, IStdOps <Element>, numOfChildren> {
public:

protected:

private:


};

#pragma SOMAsDefault (pop)

#pragma info (restore)
#pragma pack ()

#endif
