#if (defined(__IBMC__) || defined(__IBMCPP__))
#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( none )
#endif
#pragma info( restore )
#endif

#ifndef __lc_core_h
   #define __lc_core_h

   #ifdef __cplusplus
      extern "C" {
   #endif

   #ifndef  _LNK_CONV
     #ifdef _M_I386
         #define  _LNK_CONV   _Optlink
     #else
       #define  _LNK_CONV
     #endif
   #endif

   /********************************************************************/
   /*  <lc_core.h> header file                                         */
   /*                                                                  */
   /*  VisualAge for C++ for Windows, Version 3.5                      */
   /*    Licensed Material - Property of IBM                           */
   /*                                                                  */
   /*  5801-ARR and Other Materials                                    */
   /*                                                                  */
   /*  (c) Copyright IBM Corp 1991, 1996. All rights reserved.         */
   /*                                                                  */
   /********************************************************************/

#include <stddef.h>

 /*
 ** Valid type ids for type_id above.
 */
#define _LC_CAR       1
#define _LC_LOCALE    2
#define _LC_CHARMAP   3
#define _LC_CTYPE     4
#define _LC_COLLATE   5
#define _LC_NUMERIC   6
#define _LC_MONETARY  7
#define _LC_TIME      8
#define _LC_RESP      9
#define _LC_SYNTAX   10
#define _LC_TOD      11

 /*
 ** Object magic for C/C++
 */
#define _LC_MAGIC     0x4C43

 /*
 ** Version C/C++
 */
#define _LC_VERSION   0x00011000

#ifndef __lc_object
 #define __lc_object 1
   typedef struct {

       unsigned short
           type_id,
           magic;
       unsigned long
           version;

       size_t  size;

   } _LC_object_t;
#endif

typedef struct {

    _LC_object_t  hdr;

    /* Message Services API Methods */
    unsigned char
            * (*catgets)();
    void    (*catclose)();

    /* Message compression methods */
    char    *(*compress)();
    char    *(*decompress)();
    int     (*start_compress)();
    int     (*end_compress)();

    /* Initialization method */
    int     (*init)();
    void    *data;
} _LC_core_car_t;

typedef struct {

    _LC_object_t  hdr;

    /* Process code conversion methods */
    int      (*mbtowc)();
    size_t   (*mbstowcs)();
    int      (*wctomb)();
    size_t   (*wcstombs)();

    /* Character encoding length method */
    int      (*mblen)();

    /* Character display width methods */
    int      (*wcswidth)();
    int      (*wcwidth)();

    /* Character set id methods */
    int      (*csid)();
    int      (*wcsid)();

    /* character state-dependent encoding methods */
    int      (*mbsinit)();
    size_t   (*mbrlen)();
    size_t   (*mbrtowc)();
    size_t   (*wcrtomb)();
    size_t   (*mbsrtowcs)();
    size_t   (*wcsrtombs)();

    /* implementation initialization */
    int      (*init)();
    void     *data;
} _LC_core_charmap_t;


typedef struct {

    _LC_object_t  hdr;

    /* case convertersion methods */
    wchar_t  (*towupper)();
    wchar_t  (*towlower)();

    /* classification methods */
    unsigned
      int    (*wctype)();
    int      (*iswctype)();

    /* implementation initialization */
    int      (*init)();
    void     *data;
} _LC_core_ctype_t;

typedef struct {

    _LC_object_t  hdr;

    /* character collation methods */
    int      (*strcoll)();
    size_t   (*strxfrm)();

    /* process code collation methods */
    int      (*wcscoll)();
    size_t   (*wcsxfrm)();

    /* filename matching methods */
    int      (*fnmatch)();

    /* regular expression methods */
    int      (*regcomp)();
    size_t   (*regerror)();
    int      (*regexec)();
    void     (*regfree)();

    /* implementation initialization */
    int      (*init)();
    void     *data;
} _LC_core_collate_t;


typedef struct {

    _LC_object_t  hdr;

    /* time character string formatting methods */
    size_t   (*strftime)();
    char     *(*strptime)();

    /* time process code string formatting methods */
    size_t   (*wcsftime)();

    /* implementation initialization */
    int      (*init)();
    void     *data;

    /* date/time formatting convention method */
    struct dtconv  *(*localdtconv)();
} _LC_core_time_t;


typedef struct {

    _LC_object_t  hdr;

    /* character string monetary formatting method */
    int      (*strfmon)();

    /* implementation initialization */
    int      (*init)();
    void     *data;
} _LC_core_monetary_t;


typedef struct {

    _LC_object_t  hdr;

    /* implementation initialization */
    int      (*init)();
    void     *data;
} _LC_core_numeric_t;


typedef struct {

    _LC_object_t  hdr;

    /* response matching method */
    int         (*rpmatch)();

    /* implementation initialization */
    int         (*init)();
    void        *data;
} _LC_core_resp_t;


typedef struct {

    _LC_object_t  hdr;

    /* implementation initialization */
    int      (*init)();
    void     *data;
} _LC_core_syntax_t;


typedef struct {

    _LC_object_t  hdr;

    /* implementation initialization */
    int      (*init)();
    void     *data;
} _LC_core_tod_t;


typedef struct {

    _LC_object_t hdr;

    /* langinfo method */
    char         *(*nl_langinfo)();
    struct lconv * (*localeconv)();

    /* Initialization */
    int          (*init)();
    void         *data;
} _LC_core_locale_t;

   #ifdef __cplusplus
      }
   #endif

#endif

#if (defined(__IBMC__) || defined(__IBMCPP__))
#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( restore )
#endif
#pragma info( restore )
#endif
