/******************************************************************************/
/* File:   sdsstre.inl                                                        */
/* Class:                                                                     */
/*         IDSStatementRetrieve                                               */
/*                                                                            */
/******************************************************************************/

/***********************************************

    Licensed Materials - Property of IBM

    5622-880   5801-AAR

    (c) Copyright IBM Corp 1991, 1996.

************************************************/

//#include "sdsstre.hpp"

/*-----------------------------------------------------------------+
|  Constructor                                                     |
+-----------------------------------------------------------------*/
inline IDSStatementRetrieve::IDSStatementRetrieve(const char* aStatement,
                           DatastoreDB2* aDatastore )
          :IDSStatement(aStatement,aDatastore)
{

}

inline IDSStatementRetrieve::IDSStatementRetrieve(const char* aStatement,
                           DatastoreODBC* aDatastore )
          :IDSStatement(aStatement,aDatastore)
{

}

/*-----------------------------------------------------------------+
|  Destructor                                                      |
+-----------------------------------------------------------------*/
inline IDSStatementRetrieve::~IDSStatementRetrieve()
{

}

inline IDSStatementRetrieve&
IDSStatementRetrieve::execute()
{
    parameterBuffers.bindToStatement(iSQLStatement);
    iSQLStatement->executeDirect(iStatement);
    columnBuffers.bindToStatement(iSQLStatement);
    if (iSQLStatement->fetch()) {
        IString strError = ClsEnv::daxMsg(DAX_MSG_OBJECT_NOT_FOUND_OR_NOT_INSERTED);
        IDADataObjectNotFound exc(strError,DAX_MSG_OBJECT_NOT_FOUND_OR_NOT_INSERTED,IException::recoverable);
        ITHROW (exc);
    }
    //  *** disable check for non-unique object ***
    //if (iSQLStatement->moreResults()) {
    //    IString strError = ClsEnv::daxMsg(DAX_MSG_OBJECT_NOT_UNIQUE);
    //    IDADataObjectInvalid exc(strError,DAX_MSG_OBJECT_NOT_UNIQUE,IException::recoverable);
    //    ITHROW (exc);
    //}
    return *this;
}
